function [bound_S, bound_T, bound_KS]=beregn_bounds_v2(G,dist_zeros,dist_poles)

%=========================================================================\
% Bounds on S and T in the SISO-case
%=========================================================================/

[Qz, Qp, Qzp]=finn_Qz_Qp_Qzp(dist_zeros, dist_poles);
bound_S=sqrt(1+max((svd(sqrtm(pinv(Qz))*Qzp*sqrtm(pinv(Qp)))))^2);
bound_T=bound_S;        
%=========================================================================\
% Bounds on KS in the SISO-case
%=========================================================================/
%The Hankel-norm
[hankel_stab,hankel_unstab] = hankelsv(G);
if(length(hankel_unstab)==0)
    bound_KS=0;
else    
    bound_KS=1/min(hankel_unstab);
end
