%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\
% null_pol_forflytning.m
% Skal underske nrmere hvordan polene og nullpunktene forflytter seg
% NB! Husk at jeg m sjekke at regulatoren stabiliserer for alle z i z_vec
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%/
close all
clear all
clc
global data; 
z_vec=[0.25,0.30];%[0.9,0.13,0.16,0.175,0.20,0.30];%;0.175; 0.18 ; 0.20 ; 0.30]
figure
for jj=1:length(z_vec)
%=========================================================================\
%Definerer parametere
%=========================================================================/


mG_in=0.362; %l/min denne blir satt ogs i s_slug som benyttes av simulink!!!!!!! br kanskje prve  sette den bare ett sted
mL_in=8.64; %l/min denne blir satt ogs i s_slug som benyttes av simulink!!!!!!! br kanskje prve  sette den bare ett sted
z_setpkt=z_vec(jj); %0.175;%  %ventilpning det skal lineariseres rundt 
z_arbpkt=70;%Arbeidspunkt for pdraget i ytre slyfe. Se simulinkdiagram stasjonaer.sim



%=========================================================================\
%Simulerer for  finne P1, P2 og h1 stasjonrt
%=========================================================================/
simtid=6*3600; %variabelen simtid ligger i simulinkdiagrammet
sim('stasjonaer');
P1_stationary=1e5*P1_simulert.signals.values(length(P1_simulert.signals.values)); %henter ut siste verdi -> viktig  se til at reguleringen er stabil.
P2_stationary=1e5*P2_simulert.signals.values(length(P2_simulert.signals.values)); %henter ut siste verdi
h1_stationary=h1_simulert.signals.values(length(h1_simulert.signals.values)); %henter ut siste verdi


subplot(1,3,1)
plot(h1_simulert.time,h1_simulert.signals.values)
hold on

subplot(1,3,2)
plot(z.time,z.signals.values)
hold on

subplot(1,3,3)
plot(P1_simulert.time,P1_simulert.signals.values)
hold on

%=========================================================================\
%Finner den stasjonre lsningen x0 rundt z=0.3 (evnt z=0.175)
%=========================================================================/
[x0,y_stasj,data]=initialize2(z_setpkt,mG_in,mL_in,P1_stationary,h1_stationary,P2_stationary); %mer modulrt hvis jeg tar inn K1, K2, K3 og n i funksjonskallet. 


%=========================================================================\
%Lineariserer rundt den stasjonre lsningen x0 for z=0.3
%=========================================================================/
u=[z_setpkt;mG_in;mL_in;data.P0]; %u0 = u da u er konstant. z_setpkt
%Linearizing
[A,B,C,D]=linearize(@slug_3D_lin,[],x0(1:3),[],u);

    if jj==1
        poler=eig(A)';      
    else
        poler=cat(1,poler,eig(A)');
    end

iu=1; % skal ha transferfunksjonen fra iu`th input - dvs. z.
[tf_teller,tf_nevner]=ss2tf(A,B,C,D,iu); %
disp('----------------------------------------------------')
disp('Nullpunkt DP')
nullpunkt=roots(tf_teller(1,:))
disp('Nullpunkt P1') 
nullpunkt=roots(tf_teller(12,:))
for rr=1:length(nullpunkt)
    nullpunkt(rr)
end
disp('----------------------------------------------------')

   

end






disp('Polene til systemet')
poler


%=========================================================================\
%Finner transferfunksjonen mellom u=z og y=[DP rho_T w Q alpha_L alpha_Lm
%etc....] se slug_3D_lin's Y-vektor.
%=========================================================================/
% 
% for jj=1:length(z_vec)
% 
%     iu=1; % skal ha transferfunksjonen fra iu`th input - dvs. z.
%     [tf_teller,tf_nevner]=ss2tf(A(),B,C,D,iu); %
%     nullpunkt=roots(tf_teller(1,:))
% 
% end









