function [x0,data]=lineariseringspunkt(z,w_Gin,w_Lin,data)

%=========================================================================\
%Funksjon for  finne den stasjonre lsningen x0 det skal lineariseres
%                               rundt.
%=========================================================================/

%=========================================================================\
%Tuningskonstanter for  tilfredstille OLGA-data.
%=========================================================================/
%Disse er funnet fra kap 4.2.1 i paperet "A low-dimensional dynamic model
%of severe slugging for control design and analysis".
data.K1=0.0054
data.K2=6.84
data.K3=0.11
data.n=2.3
data.V_G1=12.64
data.M_G=20.6
%=========================================================================\
%(B.1)-(B.3) settes lik 0 for  finne den (ustabile) stasjonre lsningen
%                       ved gitt ventilpning z.
%=========================================================================/
w_Lout=w_Lin; %B.1
w_G1=w_Gin;   %B.2  
w_Gout=w_G1;  %B.3
%=========================================================================\
%De tilstandsavhengige interne variablene beregnes
%=========================================================================/
alpha_Lm=w_Lin/(w_Gin+w_Lin); %alpha_Lm er vskefraksjonen (massebasis) oppstrms choke-valven. Denne relasjonen gjelder KUN i det stasjonre tilfellet.
w_out=w_Gout/(1-alpha_Lm);    %B.23; N kan jeg kanskje benytte B.22 for  finne P2 eller rho_T. Men m finne en av disse variablene p en annen mte. HVILKEN/HVORDAN?
                              %Er nok i hovedsak rho_T som gr an  finne p en annen mte.  








V_L=V_LR+h1*data.A1; %B.7 m finne h1 og V_LR
%=========================================================================\
%Beregning av x0
%=========================================================================/
mL=V_L*data.rho_L; %B.6 m finne V_L : OK
mG1=P1*data.V_G1*data.M_G/(data.R*data.T); %B.4 her m jeg ha trykket P1
mG2=P2*V_G2*data.M_G/(data.R*data.T);%B.12 her m jeg ha trykket P2 og volumet V_G2

x0=[mL;mG1;mG2];
end