%=========================================================================\
% Linear combination of y= W + alpha * DP
%=========================================================================/

clear
clc
close all

s=tf('s');
W_tf=-1.0259e-7*((1.02*1e10*s-1)*(2681*s+1)*(0.393*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
DP_tf=-4.45*((0.9020*s-1)*(83.51*s-1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
alpha=1;
K_indre=10;
K_ytre=0.01;

Ti=100;

G_linkomb=W_tf+alpha*DP_tf;
G_linkomb=minreal(G_linkomb);





%=========================================================================\
% Investgation of stability
%=========================================================================/

%NB watch out for the changing of K2

% figure
% linkomb_CL=loopsens(G_linkomb,K2);
% if(linkomb_CL.Stable==1)
%     disp('Linear combination is stable')
% else
%     disp('Linear combination is NOT stable')
% end
% nyquist(K2*G_linkomb)
% hold on
% %=====================================
% K2=5
% linkomb_CL=loopsens(G_linkomb,K2);
% 
% if(linkomb_CL.Stable==1)
%     disp('Linear combination is stable')
% else
%     disp('Linear combination is NOT stable')
% end
% nyquist(K2*G_linkomb)
% %=====================================
% K2=10
% linkomb_CL=loopsens(G_linkomb,K2);
% 
% if(linkomb_CL.Stable==1)
%     disp('Linear combination is stable')
% else
%     disp('Linear combination is NOT stable')
% end
% nyquist(K2*G_linkomb)



%=========================================================================\
% Simulations
%=========================================================================/

simtid=70000;
[num_Wtf,den_Wtf]=tfdata(W_tf,'v');
[num_DPtf,den_DPtf]=tfdata(DP_tf,'v');
sim('real_ex_linkomb_W_and_DP_simulink')


%=========================================================================\
% Plots
%=========================================================================/

figure
plot(simout_linkomb_alone.time, simout_linkomb_alone.signals.values,'linewidth',1.5)
ylabel('y=\alpha DP + W')

figure
subplot(1,2,1)
% plot(simout_linkomb.time, simout_linkomb.signals.values,'r','linewidth',1.5)
plot(simout_linkomb.time, simout_linkomb.signals.values,'linewidth',1.5)
ylabel('y=\alpha DP + W')
axis([simout_linkomb.time(1) simout_linkomb.time(length(simout_linkomb.time)) 0 1.22 ])
% AXIS([XMIN XMAX YMIN YMAX])

subplot(1,2,2)
plot(simout_DP.time, simout_DP.signals.values,'linewidth',1.5)
ylabel('y=DP')






% 
% 
% %=========================================================================\
% % Analyzing the closed loop :)
% %=========================================================================/
% G1=DP_tf;
% G2=W_tf;
% K2=K_indre;
% K1=K_ytre*(1+1/(Ti*s));
% %Polene til systemet sett fra r->y1 er gitt av nullpunktene til flgende TF
% TF_r_y1_CL=(G1*K2*K1)/(1+G2*K2+G1*K2*K1+G1*K2*alpha);
% disp('Transferfunksjon fra r->y1 - BEREGNET SJL!!!')
% TF_r_y1_CL=minreal(TF_r_y1_CL)
% 
% % [a,b,c,d]=linmod('toy_ex_sim_nytt_system_without_noise');
% % TF_r_y1=ss(a,b,c,d);
% % TF_r_y1=minreal(TF_r_y1);
% % disp('Transferfunksjon fra r->y1')
% % TF_r_y1=tf(TF_r_y1)
% 
% 
% disp('Transferfunksjon PEN SLYFE!!!! r->y1 BEREGNET SJL')
% TF_r_y1_OL=(G1*K2*K1)/(1+G2*K2+G1*K2*alpha);
% TF_r_y1_OL=minreal(TF_r_y1_OL)
% 
% % [a,b,c,d]=linmod('toy_ex_sim_nytt_system_find_open_loop');
% % TF_r_y1_OL_simulink=ss(a,b,c,d);
% % TF_r_y1_OL_simulink=minreal(TF_r_y1_OL_simulink);
% % disp('Transferfunksjon PEN SLYFE!!!! r->y1 SIMULINK beregnet')
% % TF_r_y1_OL_simulink=tf(TF_r_y1_OL_simulink)
% % disp('Closed loop beregnet vha PEN slyfe')
% % TF_r_y1_CL_based_OL=minreal(TF_r_y1_OL_simulink/(1+TF_r_y1_OL_simulink))
% 
% 
% 
% step(TF_r_y1_CL,simtid)
% 
% 
% 
% 
% % figure
% % plot(paadrag.time, paadrag.signals.values,'linewidth',1.5)
% 
% % %=========================================================================\
% % % Nyquist diagram of the inner loop
% % %=========================================================================/
% % H_indre; % linerkombinasjon
% % K2;
% figure
% nyquist(K2*G_linkomb)
% 
% 
% 
% figure
% nyquist(TF_r_y1_OL)
% 
% 
% 
% 
% 
% %=========================================================================\
% % Beregn peaks
% %=========================================================================/
% 
% disp('Bounds on peaks for W_tf')
% Du=0.7;
% Dy=1;
% W_tf_skalert=inv(Dy)*W_tf*Du;
% [bound_S, bound_T, bound_KS]=beregn_bounds_v2(W_tf_skalert,tzero(W_tf_skalert),pole(W_tf_skalert))
% 
% 
% 
% disp('Bounds on peaks for DP_tf')
% disp('Transferfunksjon fra u=z -> y=DP')
% Du=0.7;
% Dy=0.5;
% DP_tf_skalert=inv(Dy)*DP_tf*Du;
% [bound_S, bound_T, bound_KS]=beregn_bounds_v2(DP_tf_skalert,tzero(DP_tf_skalert),pole(DP_tf_skalert))
% 
% 
% 
% 
% 
% %H_indre
% disp('Bounds on peaks for Indre slyfe G_linkomb')
% [bound_S, bound_T, bound_KS]=beregn_bounds_v2(G_linkomb,tzero(G_linkomb),pole(G_linkomb))








