%=========================================================================\
% Real example ; project
%=========================================================================/
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\
%NB!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%The transfer functions which is used here is for a linearization around a choke-valve opening of
%30%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%/
%-------------------------------------------------------------------------\
% Her ser jeg p linerkombinasjoner av = W,Q,DP,rho_T,alpha_LM,alpha_LT
%-------------------------------------------------------------------------/



clear
clc
close all

%-------------------------------------------------
% Definerer transferfunksjoner
%-------------------------------------------------
%Tar utgangspunkt i W og Q
s=tf('s');

W_tf=-1.0259e-7*((1.02*1e10*s-1)*(2681*s+1)*(0.393*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
%W_tf_endring1=4.2330*(s*(2681*s+1)*(0.393*s+1))/((0.494*s+1)*(9009*s^2-71.
%8*s+1)) forsk p  forenkle!
%W_tf_endring2=1.1349e4*(s^2*(0.393*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1))
%forsk p  forenkle!
ss_gain_W_tf=evalfr(W_tf,0); %Br stasjonrt vre hy slik at planten ikke driver bort!
Q_tf=(4.5889e-4)*((0.688*s+1)*(353.1*s+1)*(2227*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
%Q_tf_endring1=18.2614*(s*(0.688*s+1)*(353.1*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1))
DP=-4.45*((0.9020*s-1)*(83.51*s-1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
rho_T=-14.73*(253.5*s-1)*(2321*s+1)/((0.494*s+1)*(9009*s^2-71.8*s+1));
alpha_LM=-8.58e-10*((273.46*s-1)*(7.45e9*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
alpha_LT=-0.0188*((255.70*s-1)*(2.64e3*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));


%------------------------------------------------
% y=alpha*DP+rho_T
%------------------------------------------------
alpha=-1:0.01:3;
y=alpha*DP+rho_T;
y_min=minreal(y);

nullpunkt_DP_rhoT=tzero(y_min(1))';
for jj=2:length(y_min)
    nullpunkt_DP_rhoT=cat(1,nullpunkt_DP_rhoT,tzero(y_min(jj))');
end

figure
subplot(1,2,1)
plot(alpha,real(nullpunkt_DP_rhoT(:,1)))
title('y=alpha*rho_T+W')
xlabel('\alpha')
ylabel('Zero')
subplot(1,2,2)
plot(alpha,real(nullpunkt_DP_rhoT(:,2)))
xlabel('\alpha')
ylabel('Zero')

for jj=1:length(nullpunkt_DP_rhoT)
    if(real(nullpunkt_DP_rhoT(jj,1))<0 & real(nullpunkt_DP_rhoT(jj,2))<0)
        disp('Alle nullpunkt i VHP for linkomb DP og rho_T')
    end
end


%------------------------------------------------
% y=alpha*DP+Q
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*DP+Q_tf;
y_min=minreal(y);

nullpunkt_DP_Q=tzero(y_min(1))';
for jj=2:length(y_min)
    nullpunkt_DP_Q=cat(1,nullpunkt_DP_Q,tzero(y_min(jj))');
end

figure
subplot(1,3,1)
plot(alpha,real(nullpunkt_DP_Q(:,1)))
title('y=alpha*DP+Q')
xlabel('\alpha')
ylabel('Zero')
subplot(1,3,2)
plot(alpha,real(nullpunkt_DP_Q(:,2)))
xlabel('\alpha')
ylabel('Zero')
subplot(1,3,3)
plot(alpha,real(nullpunkt_DP_Q(:,3)))
xlabel('\alpha')
ylabel('Zero')

for jj=1:length(nullpunkt_DP_Q)
    if(real(nullpunkt_DP_Q(jj,1))<0 & real(nullpunkt_DP_Q(jj,2)) < 0 & real(nullpunkt_DP_Q(jj,3)) < 0)
        disp('Alle nullpunkt i VHP for linkomb DP og Q')
        disp('Alpha er')
        disp(jj)
    end
end

%------------------------------------------------
% y=alpha*DP+W
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*DP+W_tf;
y_min=minreal(y);

nullpunkt_DP_W=tzero(y_min(1))';
for jj=2:length(y_min)
    nullpunkt_DP_W=cat(1,nullpunkt_DP_W,tzero(y_min(jj))');
end

figure
subplot(1,3,1)
plot(alpha, real(nullpunkt_DP_W(:,1)))
title('y=alpha*DP+W')
subplot(1,3,2)
plot(alpha, real(nullpunkt_DP_W(:,2)))
subplot(1,3,3)
plot(alpha, real(nullpunkt_DP_W(:,3)))

for jj=1:length(nullpunkt_DP_W)
    if(real(nullpunkt_DP_W(jj,1))<0 & real(nullpunkt_DP_W(jj,2)) < 0 & real(nullpunkt_DP_W(jj,3)) < 0)
        disp('Alle nullpunkt i VHP for linkomb DP og W')
        disp('Alpha er')
        disp(alpha(jj))
        disp('Alpha plass er')
        disp(jj)
    end
end

%------------------------------------------------
% y=alpha*rho_T+W
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*rho_T+W_tf;
y_min=minreal(y);

nullpunkt_rhoT_W=tzero(y_min(1))';
for jj=2:length(y_min)
    nullpunkt_rhoT_W=cat(1,nullpunkt_rhoT_W,tzero(y_min(jj))');
end

figure
subplot(1,3,1)
plot(alpha,real(nullpunkt_rhoT_W(:,1)))
title('y=alpha*rho_T+W')
subplot(1,3,2)
plot(alpha,real(nullpunkt_rhoT_W(:,2)))
subplot(1,3,3)
plot(alpha,real(nullpunkt_rhoT_W(:,3)))


for jj=1:length(nullpunkt_rhoT_W)
    if(real(nullpunkt_rhoT_W(jj,1))<0 & real(nullpunkt_rhoT_W(jj,2)) < 0 & real(nullpunkt_rhoT_W(jj,3)) < 0)
        disp('Alle nullpunkt i VHP for linkomb rho_T og W')
        disp('Alpha er')
        disp(alpha(jj))
    end
end

%------------------------------------------------
% y=alpha*rho_T+Q
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*rho_T+Q_tf;
y_min=minreal(y);

nullpunkt_rhoT_Q=tzero(y_min(1))';

for jj=2:length(y_min)
    nullpunkt_rhoT_Q=cat(1,nullpunkt_rhoT_Q,tzero(y_min(jj))');
end

figure
subplot(1,3,1)
plot(alpha,real(nullpunkt_rhoT_Q(:,1)))
title('y=alpha*rho_T+Q')
subplot(1,3,2)
plot(alpha,real(nullpunkt_rhoT_Q(:,2)))
subplot(1,3,3)
plot(alpha,real(nullpunkt_rhoT_Q(:,3)))

for jj=1:length(nullpunkt_rhoT_Q)
    if(real(nullpunkt_rhoT_Q(jj,1))<0 & real(nullpunkt_rhoT_Q(jj,2)) < 0 & real(nullpunkt_rhoT_Q(jj,3)) < 0)
        disp('Alle nullpunkt i VHP for linkomb rho_T og Q')
        disp('Alpha er')
        disp(jj)
    end
end



%------------------------------------------------
% y=alpha*Q+W
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*Q_tf+W_tf;
y_min=minreal(y);

nullpunkt_Q_W=tzero(y_min(1))';

for jj=2:length(y_min)
    nullpunkt_Q_W=cat(1,nullpunkt_Q_W,tzero(y_min(jj))');
end

figure
subplot(1,3,1)
plot(alpha,real(nullpunkt_Q_W(:,1)))
title('y=alpha*Q+W')
subplot(1,3,2)
plot(alpha,real(nullpunkt_Q_W(:,2)))
subplot(1,3,3)
plot(alpha,real(nullpunkt_Q_W(:,3)))

for jj=1:length(nullpunkt_Q_W)
    if(real(nullpunkt_Q_W(jj,1))<0 & real(nullpunkt_Q_W(jj,2)) < 0 & real(nullpunkt_Q_W(jj,3)) < 0)
        disp('Alle nullpunkt i VHP for linkomb Q og W')
        disp('Alpha er')
        disp(jj)
    end
end


%------------------------------------------------
% y=alpha*DP+alpha_LM
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*DP+alpha_LM;
y_min=minreal(y);

nullpunkt_DP_alphaLM=tzero(y_min(1))';

for jj=2:length(y_min)
    nullpunkt_DP_alphaLM=cat(1,nullpunkt_DP_alphaLM,tzero(y_min(jj))');
end

figure
subplot(1,2,1)
plot(alpha,real(nullpunkt_DP_alphaLM(:,1)))
title('y=alpha*DP+alpha_LM')
subplot(1,2,2)
plot(alpha,real(nullpunkt_DP_alphaLM(:,2)))


for jj=1:length(nullpunkt_DP_alphaLM)
    if(real(nullpunkt_DP_alphaLM(jj,1))<0 & real(nullpunkt_DP_alphaLM(jj,2)) < 0)
        disp('Alle nullpunkt i VHP for linkomb DP og alphaLM')
        disp('Alpha er')
        disp(jj)
    end
end


%------------------------------------------------
% y=alpha*DP+alpha_LT
%------------------------------------------------
alpha=-6:0.01:4;
y=alpha*DP+alpha_LT;
y_min=minreal(y);

nullpunkt_DP_alphaLT=tzero(y_min(1))';
test=tzero(y_min(1))';
for jj=2:length(y_min)
    nullpunkt_DP_alphaLT=cat(1,nullpunkt_DP_alphaLT,tzero(y_min(jj))');
end


figure
subplot(1,2,1)
plot(alpha,real(nullpunkt_DP_alphaLT(:,1)))
title('y=alpha*DP+alpha_LT')
subplot(1,2,2)
plot(alpha,real(nullpunkt_DP_alphaLT(:,2)))


for jj=1:length(nullpunkt_DP_alphaLT)
    if(real(nullpunkt_DP_alphaLT(jj,1))<0 & real(nullpunkt_DP_alphaLT(jj,2)) < 0)
        disp('Alle nullpunkt i VHP for linkomb DP og alphaLT')
        disp('Alpha er')
        disp(jj)
    end
end














% %=========================================================================\
% % Bodediagram for transferfunksjonene
% %=========================================================================/
% %---------------------------------
% % Bodediagram for W_tf
% %---------------------------------
% figure 
% bode(W_tf)
% figure
% bode(W_tf_endring1)
% figure
% bode(W_tf_endring2,{1e-5,1e2})
% %---------------------------------
% % Bodediagram for Q_tf
% %--------------------------------
% figure
% bode(Q_tf)
% figure
% bode(Q_tf_endring1,{1e-5,1e1})
% %---------------------------------
% % Bodediagram for DP
% %---------------------------------
% figure
% bode(DP)
% 
% 
% 




% % =========================================================================\
% % Beregne frekvensresponsen selv for W_tf
% % =========================================================================/
% % w=logspace(-10,2,78);
% % frek_W_tf=freqresp(W_tf,w);
% % for i = 1:length(w)
% %     frek_resp_W_tf(i)=frek_W_tf(1,1,i);
% % end
% % 
% % figure
% % semilogx(w,20*log10(abs(frek_resp_W_tf)))
% % 
% % =========================================================================\
% % Beregne frekvensresponsen selv for Q_tf
% % =========================================================================/
% % w=logspace(-3,5,78);
% % frek_Q_tf=freqresp(Q_tf,w);
% % for i = 1:length(w)
% %     frek_resp_Q_tf(i)=frek_Q_tf(1,1,i);
% % end
% % 
% % figure
% % semilogx(w,20*log10(abs(frek_resp_Q_tf)))






% close all;
% 
% %-------------------------\
% % Definitions
% %-------------------------/
% 
% num_G1=5*[-1.5 1];
% den_G1=[-1 1];
% num_G2=5*[-0.5 1];
% den_G2=[-1 1];
% G1=tf(num_G1,den_G1);
% G2=tf(num_G2,den_G2);
% K_indre=50;
% K_ytre=0.1;
% Ti=10;
% 
% alpha=-0.9;%-0.9; %bruk av -0.8 gir bra resultat. alpha=-1 gir 0 steady-state gain.
% 
% s=tf('s');
% %-------------------------\
% % Diverse beregninger
% %-------------------------/
% %Beregning av nullpunktets endring ved linerkombinasjonen.
% a=-1:0.01:0;
% %Nullpunktet ligger i VHP for -1<a<-0.33. y=alpha*y1+y2
% r=(1+a)./(0.5+1.5*a); %Beregnet for hnd for dette spesifikke eksempelet.
% figure
% plot(a,r,'--','linewidth', 1.5);
% xlabel('\alpha');
% ylabel('Zero');
% grid;
% 
% %Man nsker  ha nullpunktet s langt som mulig inn i venstre halvplan for
% % f en bedre steady-state-gain. Dette er muligens egentlig ikke S viktig da
% %linerkombinasjonsmlingen frst og fremst benyttes for stabilisering i
% %indre slyfe.
% %y=alpha*y1+y2
% H=alpha*G1+G2;
% H_ss=ss(H,'min');
% H_indre=tf(H_ss)
% tzero(H_indre);
% loop_indre=loopsens(H_indre,K_indre);
% pol=(1+K_indre*0.5)/(1-4.25*K_indre) % s=(1+K*0.5)/(1-4.25*K) (-inf,-2) og (0.234,inf) MERKELIG at man kan stabilisere ved negativ K!!!
% % figure
% % bode(loop_info.Si)
% % figure
% % bode(loop_info.Li)
% disp('Indre slyfes transferfunksjon')
% inner_closed_loop=minreal(tf(loop_indre.Ti))
% H_ytre_OL=inner_closed_loop*K_ytre;
% H_ytre=loopsens(inner_closed_loop,K_ytre);
% disp('Ytre slyfens transferfunksjon')
% H_ytre_TF=minreal(tf(H_ytre.Ti))
% 
% %=========================================================================\
% % Beregne frekvensresponsen selv
% %=========================================================================/
% % w=logspace(-3,5,78);
% % frek_H_ytre_OL=freqresp(H_ytre_OL,w);
% % i=1;
% % for i = 1:length(w)
% %     frekvensrespons(i)=frek_H_ytre_OL(1,1,i);
% % end
% % 
% % figure
% % semilogx(w,20*log10(abs(frekvensrespons)))
% % 
% figure
% bode(H_ytre_OL)
% figure
% bode(H_indre*K_indre)
% %=========================================================================\
% % Simuleringer
% %=========================================================================/
% simtid=90;
% sim('toy_ex_sim_nytt_system_without_noise.mdl')
% 
% figure
% plot(meas_linkomb.time,meas_linkomb.signals.values,'--','linewidth', 1.5);
% %title('Enkel-slyfe-regulering av linerkombinasjon')
% ylabel('\alpha y_1 + y_2')
% xlabel('Time [s]');
% grid
% 
% figure
% subplot(1,2,1)
% plot(meas_linkomb2.time,meas_linkomb2.signals.values,'--','linewidth', 1.5);
% %title('Linrekombinasjon regulert i indre slyfe')
% ylabel('\alpha y_1 + y_2')
% xlabel('Time [s]');
% grid
% 
% subplot(1,2,2)
% plot(meas_y1.time,meas_y1.signals.values,'--','linewidth', 1.5);
% %title('y_1 regulert i ytre slyfe')
% ylabel('y_1')
% xlabel('Time [s]');
% AXIS([min(meas_y1.time) max(meas_y1.time) -0.4 1.2])
% grid


% 
% 
% Kc=K_indre*(1+1/(s*Ti_indre));
% loop_info=loopsens(H_min,Kc)
% 
% figure
% bode(loop_info.Si)
% 
% figure
% bode(loop_info.Ti)

%-------------------------\
% Simulation plots
%-------------------------/

% simtid=100;
% sim('toy_ex_sim_nytt_system');
% 
% figure
% plot(meas_linkomb.time,meas_linkomb.signals.values,'--','linewidth', 1.5);
% title('Simulering av regulering av linerkombinasjon')
% ylabel('\alpha y_1 + y_2')
% xlabel('Tid [s]');
% grid






