%=========================================================================\
% Toy example ; project
%=========================================================================/
close all;
clear
clc
%-------------------------\
% Definitions
%-------------------------/

num_G1=5*[-1.5 1];
den_G1=[-1 1];
num_G2=5*[-0.5 1];
den_G2=[-1 1];
G1=tf(num_G1,den_G1);
G2=tf(num_G2,den_G2);
K_indre=50;
K_ytre=0.1;
Ti=10;

alpha=-0.9;%-0.9; %bruk av -0.8 gir bra resultat. alpha=-1 gir 0 steady-state gain.

s=tf('s');
%-------------------------\
% Diverse beregninger
%-------------------------/
%Beregning av nullpunktets endring ved linerkombinasjonen.
a=-1:0.01:0;
%Nullpunktet ligger i VHP for -1<a<-0.33. y=alpha*y1+y2
r=(1+a)./(0.5+1.5*a); %Beregnet for hnd for dette spesifikke eksempelet.
figure
plot(a,r,'--','linewidth', 1.5);
xlabel('\alpha');
ylabel('Zero');
grid;

%Man nsker  ha nullpunktet s langt som mulig inn i venstre halvplan for
% f en bedre steady-state-gain. Dette er muligens egentlig ikke S viktig da
%linerkombinasjonsmlingen frst og fremst benyttes for stabilisering i
%indre slyfe.
%y=alpha*y1+y2
H=alpha*G1+G2;
H_ss=ss(H,'min');
H_indre=tf(H_ss)
tzero(H_indre);
loop_indre=loopsens(H_indre,K_indre);
pol=(1+K_indre*0.5)/(1-4.25*K_indre) % s=(1+K*0.5)/(1-4.25*K) (-inf,-2) og (0.234,inf) MERKELIG at man kan stabilisere ved negativ K!!!
% figure
% bode(loop_info.Si)
% figure
% bode(loop_info.Li)
disp('Indre slyfes transferfunksjon')
inner_closed_loop=minreal(tf(loop_indre.Ti))
H_ytre_OL=inner_closed_loop*K_ytre;
H_ytre=loopsens(inner_closed_loop,K_ytre);
disp('Ytre slyfens transferfunksjon')
H_ytre_TF=minreal(tf(H_ytre.Ti))

%=========================================================================\
% Beregne frekvensresponsen selv
%=========================================================================/
% w=logspace(-3,5,78);
% frek_H_ytre_OL=freqresp(H_ytre_OL,w);
% i=1;
% for i = 1:length(w)
%     frekvensrespons(i)=frek_H_ytre_OL(1,1,i);
% end
% 
% figure
% semilogx(w,20*log10(abs(frekvensrespons)))
% 
% figure
% bode(H_ytre_OL)
%=========================================================================\
% Simuleringer
%=========================================================================/
simtid=90;
sim('toy_ex_sim_nytt_system_without_noise.mdl')

figure
plot(meas_linkomb.time,meas_linkomb.signals.values,'--','linewidth', 1.5);
%title('Enkel-slyfe-regulering av linerkombinasjon')
ylabel('\alpha y_1 + y_2')
xlabel('Time [s]');
grid

figure
subplot(1,2,1)
plot(meas_linkomb2.time,meas_linkomb2.signals.values,'--','linewidth', 1.5);
%title('Linrekombinasjon regulert i indre slyfe')
ylabel('\alpha y_1 + y_2')
xlabel('Time [s]');
grid

subplot(1,2,2)
plot(meas_y1.time,meas_y1.signals.values,'--','linewidth', 1.5);
%title('y_1 regulert i ytre slyfe')
ylabel('y_1')
xlabel('Time [s]');
AXIS([min(meas_y1.time) max(meas_y1.time) -0.4 1.2])
grid


%=========================================================================\
% ser p G1,og nyquist-diagram
%=========================================================================/
k=-0.18
figure
nyquist(k*G1)





% 
% 
% Kc=K_indre*(1+1/(s*Ti_indre));
% loop_info=loopsens(H_min,Kc)
% 
% figure
% bode(loop_info.Si)
% 
% figure
% bode(loop_info.Ti)

%-------------------------\
% Simulation plots
%-------------------------/

% simtid=100;
% sim('toy_ex_sim_nytt_system');
% 
% figure
% plot(meas_linkomb.time,meas_linkomb.signals.values,'--','linewidth', 1.5);
% title('Simulering av regulering av linerkombinasjon')
% ylabel('\alpha y_1 + y_2')
% xlabel('Tid [s]');
% grid






