%=========================================================================\
% Toy example ; project
%=========================================================================/
close all;
clc;
clear;

%-------------------------\
% Definitions
%-------------------------/

num_G1=5*[-1.5 1];
den_G1=[-1 1];
num_G2=5*[-0.5 1];
den_G2=[-1 1];
G1=tf(num_G1,den_G1);
G2=tf(num_G2,den_G2);
K_indre=20;
K_ytre=0.1;
Ti=10;
alpha=-0.9;%-0.9; %bruk av -0.8 gir bra resultat. alpha=-1 gir 0 steady-state gain.

s=tf('s');
%-------------------------\
% Diverse beregninger
%-------------------------/
%Beregning av nullpunktets endring ved linerkombinasjonen.
a=-1:0.01:0;
%Nullpunktet ligger i VHP for -1<a<-0.33. y=alpha*y1+y2
r=(1+a)./(0.5+1.5*a); %Beregnet for hnd for dette spesifikke eksempelet.
figure
plot(a,r,'--','linewidth', 1.5);
xlabel('\alpha');
ylabel('Zero');
grid;

%Man nsker  ha nullpunktet s langt som mulig inn i venstre halvplan for
% f en bedre steady-state-gain. Dette er muligens egentlig ikke S viktig da
%linerkombinasjonsmlingen frst og fremst benyttes for stabilisering i
%indre slyfe.
%y=alpha*y1+y2
H=alpha*G1+G2;
H_ss=ss(H,'min');
H_indre=tf(H_ss)
tzero(H_indre);
loop_indre=loopsens(H_indre,K_indre);
pol=(1+K_indre*0.5)/(1-4.25*K_indre) % s=(1+K*0.5)/(1-4.25*K) (-inf,-2) og (0.234,inf) MERKELIG at man kan stabilisere ved negativ K!!!
% figure
% bode(loop_info.Si)
% figure
% bode(loop_info.Li)



%=========================================================================\
% Simuleringer
%=========================================================================/
simtid=90;
sim('toy_ex_sim_nytt_system_without_noise.mdl')

figure
plot(meas_linkomb.time,meas_linkomb.signals.values,'--','linewidth', 1.5);
%title('Enkel-slyfe-regulering av linerkombinasjon')
ylabel('\alpha y_1 + y_2')
xlabel('Time [s]');
grid

figure
subplot(1,2,1)
plot(meas_linkomb2.time,meas_linkomb2.signals.values,'linewidth', 1.5);
%title('Linrekombinasjon regulert i indre slyfe')
ylabel('\alpha y_1 + y_2')
xlabel('Time [s]');
grid

subplot(1,2,2)
plot(meas_y1.time,meas_y1.signals.values,'linewidth', 1.5);
hold on
%title('y_1 regulert i ytre slyfe')
reference
plot(reference.time,reference.signals.values,'--','linewidth',1.5)
ylabel('y_1')
xlabel('Time [s]');
AXIS([min(meas_y1.time) max(meas_y1.time) -0.4 1.2])
grid




%=========================================================================\
% Analyzing the closed loop
%=========================================================================/
% G1;
% G2;
% K2=K_indre;
% K1=K_ytre*(1+1/(Ti*s));
% %Polene til systemet sett fra r->y1 er gitt av nullpunktene til flgende TF
% TF_r_y1_CL=(G1*K2*K1)/(1+G2*K2+G1*K2*K1+G1*K2*alpha);
% disp('Transferfunksjon fra r->y1 - BEREGNET SJL!!!')
% TF_r_y1_CL=minreal(TF_r_y1_CL)
% 
% [a,b,c,d]=linmod('toy_ex_sim_nytt_system_without_noise');
% TF_r_y1=ss(a,b,c,d);
% TF_r_y1=minreal(TF_r_y1);
% disp('Transferfunksjon fra r->y1')
% TF_r_y1=tf(TF_r_y1)
% 
% 
% disp('Transferfunksjon PEN SLYFE!!!! r->y1 BEREGNET SJL')
% TF_r_y1_OL=(G1*K2*K1)/(1+G2*K2+G1*K2*alpha);
% TF_r_y1_OL=minreal(TF_r_y1_OL)
% 
% [a,b,c,d]=linmod('toy_ex_sim_nytt_system_find_open_loop');
% TF_r_y1_OL_simulink=ss(a,b,c,d);
% TF_r_y1_OL_simulink=minreal(TF_r_y1_OL_simulink);
% disp('Transferfunksjon PEN SLYFE!!!! r->y1 SIMULINK beregnet')
% TF_r_y1_OL_simulink=tf(TF_r_y1_OL_simulink)
% disp('Closed loop beregnet vha PEN slyfe')
% TF_r_y1_CL_based_OL=minreal(TF_r_y1_OL_simulink/(1+TF_r_y1_OL_simulink))
% 
% 
% 
% step(TF_r_y1,simtid)

% %=========================================================================\
% % Nyquist diagram of the inner loop
% %=========================================================================/
% H_indre; % linerkombinasjon
% K2;
% figure
% nyquist(K2*H_indre)
% 
% 
% 
% figure
% nyquist(TF_r_y1_OL)
% 
% 
% 
% figure
% plot(paadrag.time,paadrag.signals.values,'--','linewidth', 1.5);
% 
% %=========================================================================\
% % Beregn peaks
% %=========================================================================/
% 
% 
% 
% disp('Bounds on peaks for G1')
% [bound_S, bound_T, bound_KS]=beregn_bounds_v2(G1,tzero(G1),pole(G1))
% disp('Bounds on peaks for G2')
% [bound_S, bound_T, bound_KS]=beregn_bounds_v2(G2,tzero(G2),pole(G2))
% %H_indre
% disp('Bounds on peaks for Indre slyfe')
% [bound_S, bound_T, bound_KS]=beregn_bounds_v2(H_indre,tzero(H_indre),pole(H_indre))





























